#include <stdio.h>
#include <stdlib.h>

enum { ASCII=0, HTML, TEX};

#define TEX_END "\n\\end\n% Local Variables:\n% TeX-command-default: \"TeX\"\n% End:\n"
#define HTML_END "\n</body>\n</html>\n"

char *countries[] = {
"AD", "Andorra",
"AE", "United Arab Emirates",
"AF", "Afghanistan",
"AG", "Antigua and Barbuda",
"AI", "Anguilla",
"AL", "Albania",
"AM", "Armenia",
"AN", "Netherlands Antilles",
"AO", "Angola",
"AQ", "Antarctica",
"AR", "Argentina",
"AS", "American Samoa",
"AT", "Austria",
"AU", "Australia",
"AW", "Aruba",
"AZ", "Azerbaijan",
"BA", "Bosnia and Herzegovina",
"BB", "Barbados",
"BD", "Bangladesh",
"BE", "Belgium",
"BF", "Burkina Faso",
"BG", "Bulgaria",
"BH", "Bahrain",
"BI", "Burundi",
"BJ", "Benin",
"BM", "Bermuda",
"BN", "Brunei",
"BO", "Bolivia",
"BR", "Brazil",
"BS", "Bahamas",
"BT", "Bhutan",
"BV", "Bouvet Island",
"BW", "Botswana",
"BY", "Belarus",
"BZ", "Belize",
"CA", "Canada",
"CC", "Cocos",
"CD", "Congo, Democratic Republic",
"CF", "Central African Republic",
"CG", "Congo, Republic of",
"CH", "Switzerland",
"CI", "Cote d'Ivoire",
"CK", "Cook Islands",
"CL", "Chile",
"CM", "Cameroon",
"CN", "China",
"CO", "Colombia",
"CR", "Costa Rica",
"CU", "Cuba",
"CV", "Cape Verde",
"CX", "Christmas Island",
"CY", "Cyprus",
"CZ", "Czech Republic",
"DE", "Germany",
"DJ", "Djibouti",
"DK", "Denmark",
"DO", "Dominican Republic",
"DM", "Dominica",
"DZ", "Algeria",
"EC", "Ecuador",
"EE", "Estonia",
"EG", "Egypt",
"EH", "Western Sahara",
"ER", "Eritrea",
"ES", "Spain",
"ET", "Ethiopia",
"FI", "Finland",
"FJ", "Fiji",
"FK", "Falkland",
"FM", "Micronesia",
"FO", "Faroe Islands",
"FR", "France",
"GA", "Gabon",
"GB", "United Kingdom",
"GD", "Grenada",
"GS", "South Georgia",
"GE", "Georgia",
"GF", "French Guiana",
"GG", "Guernsey",
"GH", "Ghana",
"GI", "Gibraltar",
"GL", "Greenland",
"GM", "Gambia",
"GP", "Guadeloupe",
"GQ", "Equatorial Guinea",
"GW", "Guinea-Bissau",
"PG", "Papua New Guinea",
"GN", "Guinea",
"GR", "Greece",
"GT", "Guatemala",
"GU", "Guam",
"GY", "Guyana",
"HK", "Hong Kong",
"HM", "Heard",
"HN", "Honduras",
"HR", "Croatia",
"HT", "Haiti",
"HU", "Hungary",
"ID", "Indonesia",
"IE", "Ireland",
"IL", "Israel",
"IM", "Man",
"IO", "British Indian Ocean Territory",
"IN", "India",
"IQ", "Iraq",
"IR", "Iran",
"IS", "Iceland",
"IT", "Italy",
"JE", "Jersey",
"JM", "Jamaica",
"JO", "Jordan",
"JP", "Japan",
"KE", "Kenya",
"KG", "Kyrgyzstan",
"KH", "Cambodia",
"KI", "Kiribati",
"KM", "Comoros",
"KN", "Kitts",
"KP", "Korea, North",
"KR", "Korea, South",
"KW", "Kuwait",
"KY", "Cayman Islands",
"KZ", "Kazakhstan",
"LA", "Laos",
"LB", "Lebanon",
"LC", "Saint Lucia",
"LI", "Liechtenstein",
"LK", "Sri Lanka",
"LR", "Liberia",
"LS", "Lesotho",
"LT", "Lithuania",
"LU", "Luxembourg",
"LV", "Latvia",
"LY", "Libya",
"MA", "Morocco",
"MC", "Monaco",
"MD", "Moldova",
"MG", "Madagascar",
"MH", "Marshall Islands",
"MK", "Macedonia",
"ML", "Mali",
"MM", "Burma",
"MN", "Mongolia",
"MO", "Macau",
"MP", "Northern Mariana Islands",
"MQ", "Martinique",
"MR", "Mauritania",
"MS", "Montserrat",
"MT", "Malta",
"MU", "Mauritius",
"MV", "Maldives",
"MW", "Malawi",
"MX", "Mexico",
"MY", "Malaysia",
"MZ", "Mozambique",
"NA", "Namibia",
"NC", "New Caledonia",
"NF", "Norfolk Island",
"NG", "Nigeria",
"NE", "Niger",
"NI", "Nicaragua",
"NL", "Netherlands",
"NO", "Norway",
"NP", "Nepal",
"NR", "Nauru",
"NU", "Niue",
"NZ", "New Zealand",
"OM", "Oman",
"PA", "Panama",
"PC", "Paracel Islands",
"PE", "Peru",
"PF", "French Polynesia",
"PH", "Philippines",
"PK", "Pakistan",
"PL", "Poland",
"PM", "Saint Pierre and Miquelon",
"PN", "Pitcairn Islands",
"PR", "Puerto Rico",
"PS", "Palestine",
"PT", "Portugal",
"PW", "Palau",
"PY", "Paraguay",
"QA", "Qatar",
"RE", "Reunion",
"RO", "Romania",
"RU", "Russia",
"RW", "Rwanda",
"SA", "Saudi Arabia",
"SB", "Solomon Islands",
"SC", "Seychelles",
"SD", "Sudan",
"SE", "Sweden",
"SG", "Singapore",
"SH", "Saint Helena",
"SI", "Slovenia",
"SJ", "Svalbard",
"SK", "Slovakia",
"SL", "Sierra Leone",
"SM", "San Marino",
"SN", "Senegal",
"SO", "Somalia",
"SR", "Suriname",
"ST", "Sao Tome and Principe",
"SV", "El Salvador",
"SY", "Syria",
"SZ", "Swaziland",
"TC", "Turks and Caicos Islands",
"TD", "Chad",
"TF", "French Southern and Antarctic Lands",
"TG", "Togo",
"TH", "Thailand",
"TJ", "Tajikistan",
"TK", "Tokelau",
"TM", "Turkmenistan",
"TN", "Tunisia",
"TO", "Tonga",
"TP", "Timor",
"TR", "Turkey",
"TT", "Trinidad and Tobago",
"TV", "Tuvalu",
"TW", "Taiwan",
"TZ", "Tanzania",
"UA", "Ukraine",
"UG", "Uganda",
"US", "United States",
"UY", "Uruguay",
"UZ", "Uzbekistan",
"VA", "Holy See",
"VC", "Vincent",
"VE", "Venezuela",
"VG", "British Virgin Islands",
"VI", "Virgin Islands",
"VN", "Vietnam",
"VU", "Vanuatu",
"WF", "Wallis and Futuna",
"WS", "Samoa",
"YE", "Yemen",
"YT", "Mayotte",
"YU", "Yugoslavia",
"ZA", "South Africa",
"ZM", "Zambia",
"ZW", "Zimbabwe"
};

int country_index[676];
static int width;
static int format, paropen;

void reduce(char *str)
{
int i, j;

   i = 0;
   j = 0;

   while (str[i]  && isspace(str[i])) ++i;

   while (str[i]) {
      if (isspace(str[i])) {
         while (str[i]  && isspace(str[i])) ++i;
	 if (str[i]) {
            str[j] = ' ';
            ++j;
	 }
      }
      str[j] = str[i];
      ++i;
      ++j;
   }
   str[j] = '\0';
}

void reformat(char *str)
{
char buf[65536];
int i, ip, j, k, kp, kini, l;

   strcpy(buf, str); 
   l = strlen(buf);
   i = 0;
   if (format==ASCII) {
      j = 1;
      k = 1;
      str[0] = ' ';
   } else {
      j = 0;
      k = 0;
      *str = '\0';
   }

   if (format==ASCII) {
      if (index(buf, ':')) 
         kini = 4;
      else
         kini = 2;
   } else {
      kini = 0;
      if (index(buf, ':')) paropen = 1;
   }

   while (i<l) {
      ip = i;
      while (buf[ip] && !isspace(buf[ip])) ++ip;
      if (k+ip-i+1<width) {
	 if (i>0 || format==ASCII) {
	    str[j] = ' ';
	    ++j;
	    ++k;
	 }
      } else {
	 k = kini;
	 str[j] = '\n';
	 ++j;
	 for (kp=0; kp<kini; kp++) {
	    str[j] = ' ';
	    ++j;
	 }
      }
      for (kp=i; kp<ip; kp++) {
	 if (format==TEX) {
	    if (paropen==1 && buf[kp]==':') {
               str[j] = '}';
	       ++j;
	       ++k;
               str[j] = '\\';
	       ++j;
	       ++k;
               str[j] = '/';
	       ++j;
	       ++k;
	       paropen = 2;
	    }
	    if (buf[kp]=='%' || buf[kp]=='$' || buf[kp]=='#') {
               str[j] = '\\';
	       ++j;
	       ++k;
	    }
	 } else
	 if (format==HTML) {
	    if (paropen==1 && buf[kp]==':') {
               str[j] = '<';
	       ++j;
	       ++k;
               str[j] = '/';
	       ++j;
	       ++k;
               str[j] = 'i';
	       ++j;
	       ++k;
               str[j] = '>';
	       ++j;
	       ++k;
	       paropen = 2;
	    }
	 }
         str[j] = buf[kp];
	 ++j;
         ++k;
      }
      i = ip+1;
   }
   str[j] = '\0';
}

void usage()
{
   printf("Usage:\n"
          "  fact_extract [-help] [-tex] [-html] [-mono file] [-width w] -source file\n");
   exit(0);
}

int main(int argc, char **argv)
{
FILE *fd, *fo = NULL;
char *ptr, *ptrp;
char buf[512], outfile[512], monofile[512];
int i, l, start, number, numcountries;
char *sourcename;
char textbuf[65536];
char tag[2048], firstpart[20], suffix[10];

    width = 78; 
    *monofile = '\0';
    format = ASCII;
    paropen = 0;
    strcpy(suffix, "txt");

    for (i=1; i<argc; i++) { 
       if (i<argc-1 && !strcmp(argv[i], "-source")) {
          sourcename = argv[++i];
       } else
       if (i<argc-1 && !strcmp(argv[i], "-mono")) {
	  strcpy(monofile, argv[++i]);
       } else
       if (i<argc-1 && !strcmp(argv[i], "-width")) {
          width = atoi(argv[++i]);
	  if (width<20) width = 20;
	  if (width>256) width = 256;
       } else
       if (!strcmp(argv[i], "-h") || !strcmp(argv[i], "-help")) {
	  usage();
       } else      
       if (!strcmp(argv[i], "-tex")) {
	  width = 72;
	  format = TEX;
          strcpy(suffix, "tex");
       } else
       if (!strcmp(argv[i], "-html")) {
	  width = 72;
	  format = HTML;
          strcpy(suffix, "html");
       }
    }

    if (!sourcename) sourcename = "";

    if (!*sourcename) {
       fprintf(stderr, "No source file name specified !!\n");
       exit(-1);
    }
    fd = fopen(sourcename, "r");
    if (!fd) {
       fprintf(stderr, "Cannot open source file %s !!\n", sourcename);
       exit(-1);
    }

    numcountries = sizeof(countries)/(2*sizeof(char *));
    for (l=0; l<numcountries; l++) {
       i = 26*(countries[2*l][0]-'A')+countries[2*l][1]-'A';
       country_index[i] = 1;
    }

    *tag = '\0';
    *textbuf = '\0';
    start = 1;
    number = 1;

    while ((ptr = fgets(buf, 510, fd))) {
       if (!strncmp(ptr, "----", 4)) {
	  start = 1;
	  number = 1;
          *tag = '\0';
          *textbuf = '\0';
	  if (*monofile) {
	     if (format==TEX)
	        fprintf(fo, "\n\\vfill\\eject\n\n");
	     else
	     if (format==HTML)
	        fprintf(fo, "\n<br><br><hr><br><br>\n\n");
	     else
	        fprintf(fo, "\n-----------------------------------------\n");
	  } else {
	     if (format==HTML)
	        fprintf(fo, "%s", HTML_END);
	     else
	     if (format==TEX)
                fprintf(fo, "%s", TEX_END);
	  }
	  continue;
       }

       if (start==1) {
	  reduce(ptr);
	  if (!*ptr) 
	     continue;
	  start = 2;
       }
       if (start==2) {
	  reduce(ptr);
          if (!*ptr) *ptr = '\n';
       }

       if (*ptr && !isspace(*ptr)) {
	  if (!*tag && !start) {
	     if (format==TEX) 
	        sprintf(tag, "\\S%d. ", number);
             else
	        sprintf(tag, "%d. ", number);
	     ++number;
	  } else
	     strcat(tag, " ");
	  l = strlen(ptr)-1;
	  while (l>=0 && isspace(ptr[l])) {
	    ptr[l] = '\0';
	    --l;
	  }
	  strcat(tag, ptr);
	  continue;
       }
       
       if (*ptr=='\n') {
          if (start==1) continue;
	  if (*tag) {
	     reduce(tag);
	     if (*tag) {
	        if (start==2) {
		  ptrp = (char *)index(tag, '(');
		   if (ptrp) {
		      if (*(ptrp-1)==' ')
                         *(ptrp-1) = '\0';
		      else
		         *ptrp = '\0';
		   }
		   sprintf(outfile, "others/%s.%s", tag, suffix);
                   for (l=0; l<strlen(outfile); ++l)
		      outfile[l] = tolower(outfile[l]);
		   for (l=0; l<numcountries; ++l) {
		      if (strstr(tag, countries[2*l+1])) {
			 sprintf(outfile, "data/%s.%s", countries[2*l],suffix);
                         i = 26*(countries[2*l][0]-'A')+countries[2*l][1]-'A';
                         country_index[i] = -1;
			 break;
		      }
		   }
		   if (ptrp) {
		      if (*ptrp == '(')
                         *(ptrp-1) = ' ';
		      else
			 *ptrp = '(';
		   }
                   for (l=0; l<strlen(outfile); ++l) {
		      outfile[l] = tolower(outfile[l]);
		      if (outfile[l]==' ') outfile[l] = '_';
		   }
		   l = strlen(outfile)-1;
		   if (outfile[l]=='_') outfile[l] = '\0';
                   if (*monofile) {
		      if (!fo) {
			 fo = fopen(monofile, "w");
			 if (format==HTML)
                            fprintf(fo, "<html>\n"
                                        "<head>\n"
                                        "<title>%s</title>\n"
				        "</head>\n<body>\n\n", monofile);
			 else
			 if (format==TEX)
                            fprintf(fo, "\\input macros.tex\n\n");
		      }
		   } else {
		      if (fo) fclose(fo);
                      fo = fopen(outfile, "w");
		      if (!fo) {
		         fprintf(stderr,"Opening of %s failed !!!\n", outfile);
			 exit(-1);
		      }
		      if (format==HTML)
                         fprintf(fo, "<html>\n"
                                        "<head>\n"
                                        "<title>%s</title>\n"
				        "</head>\n<body>\n\n", outfile);
		      else
		      if (format==TEX)
                         fprintf(fo, "\\input macros.tex\n\n");
		   }
		   if (!fo) {
		      fprintf(stderr, "Can't open %s for writing !!\n", 
                                      outfile);
		   }
		   start = 0;
		   if (format==TEX)
	              fprintf(fo, "\\title{%s}\n", tag);
		   else
		   if (format==HTML)
	              fprintf(fo, "<h1>%s</h1>\n", tag);
		   else
	              fprintf(fo, "%s\n", tag);
		   *tag = '\0';
		   continue;
		}
		if (format==TEX) {
		   if (tag[0]=='\\' && tag[1]=='S')
	              fprintf(fo, "\n\\section{%s}\n", tag);
		   else
	              fprintf(fo, "\n\\subsection{%s}\n", tag);
		} else
		if (format==HTML) {
		   if (tag[0]=='')
	              fprintf(fo, "<h3>%s</h3>\n", tag+1);
		   else
	              fprintf(fo, "<h4>%s</h4>\n", tag);
		} else
	           fprintf(fo, "\n%s\n", tag);
		*tag = '\0';
	     }
	  }
	 
	  if (*textbuf) {
	     reduce(textbuf); 
	     reformat(textbuf);
             l = strlen(textbuf)-1;
	     while (l>0 && textbuf[l]=='\n') {
	       textbuf[l] = '\0';
	       --l;
	     }
             if (format==TEX) {
	        if (paropen)
	           fprintf(fo, "\\item{{\\it %s}\n", textbuf);
		else
	           fprintf(fo, "\\item{%s}\n", textbuf);
		paropen = 0;
	     } else
             if (format==HTML) {
	        if (paropen)
	           fprintf(fo, "<i>%s\n<br>\n", textbuf);
		else
	           fprintf(fo, "%s\n<br>\n", textbuf);
		paropen = 0;
	     } else
	        fprintf(fo, "%s\n", textbuf);
	     *textbuf = '\0';
	  }
	  start = 0;
	  continue;
       }
       strncpy(firstpart, ptr, 15);
       firstpart[15] = '\0';
       strcat(tag, firstpart);
       if (strlen(ptr)>=16)
          strcat(textbuf, ptr+15);       
    }
    if (format==TEX && *monofile)
       fprintf(fo, "%s", TEX_END);
    if (format==HTML && *monofile)
       fprintf(fo, "%s", HTML_END);
    if (fd) fclose(fd);
    if (fo) fclose(fo);
    for (l=0; l<676; l++) {
       if (country_index[l] == 1) {
	  sprintf(tag, "%c%c ", 'A'+(l/26), 'A'+(l%26));
          strcat(textbuf, tag);
       }
    }
    if (*textbuf)
       fprintf(stderr, "Missing countries: %s\n", textbuf);
    exit(0);
}

