#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <zlib.h>
#include <sys/stat.h>

char *countries[] = {
"AD", "Andorra, Principality of",
"AE", "United Arab Emirates",
"AF", "Afghanistan, Islamic State of",
"AG", "Antigua & Barbuda",
"AI", "Anguilla",
"AL", "Albania",
"AM", "Armenia",
"AN", "Netherlands Antilles",
"AO", "Angola",
"AQ", "Antarctica",
"AR", "Argentina",
"AS", "American Samoa, Territory of",
"AT", "Austria",
"AU", "Australia",
"AW", "Aruba Island",
"AZ", "Azerbaijan",
"BA", "Bosnia & Herzegovina",
"BB", "Barbados",
"BD", "Bangladesh",
"BE", "Belgium, Kingdom of",
"BF", "Burkina Faso",
"BG", "Bulgaria",
"BH", "Bahrain, Emirate of",
"BI", "Burundi",
"BJ", "Benin",
"BM", "Bermuda",
"BN", "Brunei Darussalam, Sultanate of",
"BO", "Bolivia",
"BR", "Brazil, Federative Republic of",
"BS", "Bahamas, Commonwealth of the",
"BT", "Bhutan, Kingdom of",
"BV", "Bouvet Island, Territory of",
"BW", "Botswana",
"BY", "Belarus",
"BZ", "Belize",
"CA", "Canada",
"CC", "Cocos (Keeling) Islands, Territory of",
"CD", "Democratic Republic of the Congo (formerly Zaire)",
"CF", "Central African Republic",
"CG", "Congo",
"CH", "Switzerland",
"CI", "Cte d'Ivoire",
"CK", "Cook Islands",
"CL", "Chile",
"CM", "Cameroon",
"CN", "People's Republic of China",
"CO", "Colombia",
"CR", "Costa Rica",
"CU", "Cuba",
"CV", "Cape Verde",
"CX", "Christmas Island, Territory of",
"CY", "Cyprus",
"CZ", "Czech Republic",
"DE", "Germany, Federal Republic of",
"DJ", "Djibouti",
"DK", "Denmark, Kingdom of",
"DM", "Dominica, Commonwealth of",
"DO", "Dominican Republic",
"DZ", "Algeria, Democratic Popular Republic of",
"EC", "Ecuador",
"EE", "Estonia",
"EG", "Egypt, Arab Republic of",
"EH", "Western Sahara",
"ER", "Eritrea",
"ES", "Spain, Kingdom of",
"ET", "Ethiopia, Federal Democratic Republic of",
"FI", "Finland",
"FJ", "Fiji Islands",
"FK", "Falkland Islands, Colony of (Islas Malvinas)",
"FM", "Micronesia, Federated States of",
"FO", "Faroe Islands",
"FR", "France",
"GA", "Gabon",
"GB", "Great Britain",
"GD", "Grenada",
"GE", "Georgia",
"GF", "French Guyana, Overseas Department of",
"GG", "Guernsey, Bailiwick of",
"GH", "Ghana",
"GI", "Gibraltar",
"GL", "Greenland",
"GM", "Gambia",
"GN", "Guinea",
"GP", "Guadeloupe & Dependancies, Overseas Department of",
"GQ", "Equatorial Guinea",
"GR", "Greece",
"GS", "South Georgia & the South Sandwich Islands, Territory of",
"GT", "Guatemala",
"GU", "Guam, Territory of",
"GW", "Guinea Bissau",
"GY", "Guyana, Cooperative Republic of",
"HK", "Hong Kong, Special Administrative Region of",
"HM", "Heard & Mc Donald Islands, Territory of",
"HN", "Honduras",
"HR", "Croatia",
"HT", "Haiti",
"HU", "Hungary",
"ID", "Indonesia",
"IE", "Ireland",
"IL", "Israel, State of",
"IM", "Isle of Man, Territory of",
"IN", "India",
"IO", "British Territory of the Indian Ocean",
"IQ", "Iraq",
"IR", "Iran, Islamic Republic of",
"IS", "Iceland",
"IT", "Italy",
"JE", "Jersey, Bailiwick of",
"JM", "Jamaica",
"JO", "Jordan, Hashemite Kingdom of",
"JP", "Japan, Imperial State of",
"KE", "Kenya",
"KG", "Kyrgyzstan",
"KH", "Cambodia, Kingdom of",
"KI", "Kiribati",
"KM", "Comoros",
"KN", "Saint Kitts & Nevis",
"KP", "Korea, Democratic People's Republic of (North Korea)",
"KR", "Korea, South",
"KW", "Kuwait, Emirate of",
"KY", "Cayman Islands",
"KZ", "Kazakhstan",
"LA", "Laos, People's Democratic Republic",
"LB", "Lebanon",
"LC", "Saint Lucia",
"LI", "Liechtenstein, Principality of",
"LK", "Sri Lanka",
"LR", "Liberia",
"LS", "Lesotho, Kingdom of",
"LT", "Lithuania",
"LU", "Luxembourg, Grand Duchy of",
"LV", "Latvia",
"LY", "Libyan Arab Jamahiriya, Socialist People's",
"MA", "Morocco, Kingdom of",
"MC", "Monaco, Principality of",
"MD", "Moldova",
"MG", "Madagascar",
"MH", "Marshall Islands",
"MK", "Macedonia, The Former Yugoslav Republic of",
"ML", "Mali",
"MM", "Myanmar (Burma)",
"MN", "Mongolia",
"MO", "Macau, Special Administrative Region of",
"MP", "Northern Mariana Islands, Commonwealth of the",
"MQ", "Martinique, Overseas Department of the",
"MR", "Mauritania, Islamic Republic of",
"MS", "Montserrat, Territory of",
"MT", "Malta",
"MU", "Mauritius",
"MV", "Maldives",
"MW", "Malawi",
"MX", "Mexico (United Mexican States)",
"MY", "Malaysia, Kingdom of",
"MZ", "Mozambique",
"NA", "Namibia",
"NC", "New Caledonia, Overseas Territory of",
"NE", "Niger",
"NF", "Norfolk Island, Territory of",
"NG", "Nigeria, Federal Republic of",
"NI", "Nicaragua",
"NL", "Netherlands, Kingdom of the",
"NO", "Norway, Kingdom of",
"NP", "Nepal, Kingdom of",
"NR", "Nauru",
"NU", "Niue",
"NZ", "New Zealand",
"OM", "Oman, Sultanate of",
"PA", "Panama, Unified Republic of",
"PC", "Paracel Islands, Territory of",
"PE", "Peru",
"PF", "French Polynesia, Overseas Territory of",
"PG", "Papua New Guinea, Independent State of",
"PH", "Philippines",
"PK", "Pakistan, Islamic Republic of",
"PL", "Poland",
"PM", "Saint Pierre & Miquelon, Overseas Territorial Collectivity of",
"PN", "Pitcairn Islands",
"PR", "Puerto Rico, Commonwealth of",
"PS", "Palestine, Occupied Territory of",
"PT", "Portugal",
"PW", "Palau",
"PY", "Paraguay",
"QA", "Qatar, Emirate of",
"RE", "Runion, Overseas Department of the",
"RO", "Romania",
"RU", "Russia, Federation of",
"RW", "Rwanda",
"SA", "Saudi Arabia, Kingdom of",
"SB", "Solomon Islands",
"SC", "Seychelles",
"SD", "Sudan",
"SE", "Sweden, Kingdom of",
"SG", "Singapore",
"SH", "Saint Helena",
"SI", "Slovenia",
"SJ", "Svlbard & Jan Mayen Islands, Territory of",
"SK", "Slovakia",
"SL", "Sierra Leone",
"SM", "San Marino",
"SN", "Sngal",
"SO", "Somalia",
"SR", "Suriname",
"ST", "So Tom & Prncipe",
"SV", "El Salvador",
"SY", "Syria, Arab Republic of",
"SZ", "Swaziland",
"TC", "Turks & Caicos Islands, Territory of",
"TD", "Chad",
"TF", "French Austral & Antartic Territories",
"TG", "Togo",
"TH", "Thailand, Kingdom of",
"TJ", "Tajikistan",
"TK", "Tokelau",
"TM", "Turkmenistan",
"TN", "Tunisia",
"TO", "Tonga, Kingdom of",
"TP", "Timor, East",
"TR", "Turkey",
"TT", "Trinidad & Tobago",
"TV", "Tuvalu",
"TW", "Taiwan, Republic of China",
"TZ", "Tanzania, United Republic of",
"UA", "Ukraine",
"UG", "Uganda",
"US", "United States of America, Federal Union of the",
"UY", "Uruguay",
"UZ", "Uzbekistan",
"VA", "Holy See, State of Vatican City",
"VC", "Saint Vincent & the Grenadines",
"VE", "Venezuela",
"VG", "Virgin Islands, British Territory of the",
"VI", "Virgin Islands, U.S. Territory of the",
"VN", "Viet Nam, Socialist Republic of",
"VU", "Vanuatu",
"WF", "Wallis & Futuna Islands, Overseas Territory of",
"WS", "Samoa, Independent State of (Western Samoa)",
"YE", "Yemen",
"YT", "Mayotte, Territorial Collectivity of",
"YU", "Yugoslavia, Federation of",
"ZA", "South Africa",
"ZM", "Zambia",
"ZW", "Zimbabwe"
};

char * currencies[] = {
"AE", "Dirham, 1000 fils",
"AF", "Afghani, 100 puls",
"AR", "Austral, 100 centavos",
"AT", "Euro, 100 cents (Schilling, 100 groschen)",
"AU", "Dollar, 100 cents",
"BB", "Dollar, 100 cents",
"BE", "Euro, 100 cents (Franc, 100 centimes)",
"BG", "Lev, 100 stotinki",
"BH", "Dinar, 1000 fils",
"BJ", "Franc, 100 centimes",
"BN", "Dollar, 100 cents or sen",
"BO", "Boliviano, 100 centavos",
"BS", "Dollar, 100 cents",
"BZ", "Dollar, 100 cents",
"CA", "Dollar, 100 cents",
"CF", "Franc, 100 centimes",
"CG", "Franc, 100 centimes",
"CH", "Franc, 100 centimes",
"CI", "Franc, 100 centimes",
"CL", "Peso, 100 centavos",
"CM", "Franc, 100 centimes",
"CN", "Yuan, 10 fen",
"CO", "Peso, 100 centavos",
"CR", "Colon, 100 centimos",
"CU", "Peso, 100 centavos",
"CZ", "Koruna, 100 halers",
"DE", "Euro, 100 cents (Deutsche mark, 100 pfennige)",
"DJ", "Franc, 100 centimes",
"DK", "Euro, 100 cents (Krone, 100 ore)",
"DO", "Peso, 100 centavos",
"DZ", "Dinar, 100 centimes",
"EC", "Sucre, 100 centavos",
"EG", "Pound, 100 piastres",
"ES", "Euro, 100 cents (Peseta, 100 centimos)",
"ET", "Birr, 100 cents",
"FI", "Euro, 100 cents (Markka, 100 pennia)",
"FJ", "Dollar, 100 cents",
"FR", "Euro, 100 cents (Franc, 100 centimes)",
"GA", "Franc, 100 centimes",
"GB", "Pound, 100 pence",
"GF", "Dollar, 100 cents",
"GH", "Cedi, 100 pesewas",
"GM", "Dalasi, 100 bututs",
"GN", "Franc, 100 centimes",
"GR", "Euro, 100 cents (Drachma, 100 lepta)",
"GT", "Quetzal, 100 centavos",
"HK", "Dollar, 100 cents",
"HN", "Lempira, 100 centavos",
"HT", "Gourde, 100 centimes",
"HU", "Forint, 100 filler",
"ID", "Rupiah, 100 sen",
"IE", "Euro, 100 cents (Pound, 100 pence)",
"IL", "Shekel, 100 agorot",
"IN", "Rupee, 100 paise",
"IQ", "Dinar, 1000 fils",
"IS", "Krona, 100 aurar",
"IT", "Euro, 100 cents (Lira, 100 centesimi)",
"JM", "Dollar, 100 cents",
"JO", "Dinar, 1000 fils",
"JP", "Yen, 100 cen",
"KE", "Shilling, 100 cents",
"KR", "Won, 100 chon",
"KW", "Dinar, 1000 fils",
"KY", "Dollar, 100 cents",
"LB", "Pound, 100 piastres",
"LK", "Rupee, 100 cents",
"LU", "Euro, 100 cents (Franc, 100 centimes)",
"MA", "Dirham, 100 centimes",
"MN", "Tugrik, 100 mongo",
"MR", "Ouguiya, 5 khoums",
"MT", "Lira or pound, 100 cents",
"MU", "Rupee, 100 cents",
"MV", "Rufiyaa, 100 laari",
"MW", "Kwacha, 100 tambala",
"MX", "Peso, 100 centavos",
"MY", "Ringgit, 100 sen",
"NE", "Franc, 100 centimes",
"NI", "Cordoba, 100 centavos",
"NL", "Euro, 100 cents (Guilder, 100 cents)",
"NO", "Krone, 100 ore",
"NP", "Rupee, 100 paisa",
"NZ", "Dollar, 100 cents",
"OM", "Riyal-omani, 1000 baiza",
"PE", "Inti, 100 centimes",
"PG", "Kina, 100 toea",
"PH", "Peso, 100 centavos",
"PK", "Rupee, 100 paisa",
"PL", "Zloty, 100 groszy",
"PT", "Euro, 100 cents (Escudo, 100 centavos)",
"PY", "Guarani, 100 centimos",
"QA", "Riyal, 100 dirhams",
"RO", "Leu, 100 bani",
"SA", "Riyal, 100 dirhams",
"SB", "Dollar, 100 cents",
"SC", "Rupee, 100 cents",
"SD", "Pound, 100 piastres",
"SE", "Euro, 100 cents (Krona, 100 ore)",
"SG", "Dollar, 100 cents",
"SL", "Leone, 100 cents",
"SN", "Franc, 100 centimes",
"SO", "Shilling, 100 cents",
"SR", "Guilder, 100 cents",
"SV", "Colon, 100 centavos",
"SY", "Pound, 100 piastres",
"TD", "Franc, 100 centimes",
"TG", "Franc, 100 centimes",
"TH", "Baht, 100 satang",
"TN", "Dinar, 1000 millimes",
"TR", "Lira, 100 kurus",
"TT", "Dollar, 100 cents",
"TW", "Dollar, 100 cents",
"TZ", "Shilling, 100 cents",
"UG", "Shilling, 100 cents",
"US", "Dollar, 100 cents",
"UY", "Peso, 100 centesimos",
"VE", "Bolivar, 100 centimos",
"VN", "Dong, 100 xu",
"WS", "Tala, 100 sene",
"YU", "Dinar, 100 paras",
"ZA", "Rand, 100 cents",
"ZM", "Kwacha, 100 ngwee",
"ZW", "Dollar, 100 cents"
};

char *extradata[] = {
"AD", "Andorra la Vella", "468", "67627",
"AE", "Abu Dhabi", "82880", "2407460",
"AF", "Kabul", "652000", "26813057",
"AG", "Saint John's", "442", "66970",
"AL", "Tiran", "28748", "3510484",
"AM", "Yerevan", "29800", "3336100",
"AO", "Luanda", "1246700", "10366031",
"AR", "Buenos Aires", "2766890", "37384816",
"AT", "Vienna", "83858", "8150835",
"AU", "Canberra", "7686850", "19357594",
"AZ", "Baku", "86600", "7771092",
"BA", "Sarajevo", "51129", "3922205",
"BB", "Bridgetown", "430", "275330",
"BD", "Dhaka", "144000", "131269860",
"BE", "Brussels", "30510", "10258762",
"BF", "Ouagadougou", "274200", "12272289",
"BG", "Sofia", "110910", "7707495",
"BH", "Al-Manmah", "620", "645361",
"BI", "Bujumbura", "27830", "6223897",
"BJ", "Porto-Novo", "112620", "6590782",
"BN", "Bandar Seri Begawan", "5770", "343653",
"BO", "La Paz", "1098580", "8300463",
"BR", "Braslia", "8511965", "174468575",
"BS", "Nassau", "13940", "297852",
"BT", "Thimphu", "47000", "2049412",
"BW", "Gaborone", "600370", "1586119",
"BY", "Minsk", "207600", "10350194",
"BZ", "Belmopan", "22960", "256062",
"CA", "Ottawa", "9976140", "31592805",
"CD", "Kinshasa", "2345410", "53624718",
"CF", "Bangui", "622984", "3576884",
"CG", "Brazzaville", "342000", "2894336",
"CH", "Bern", "41290", "7283274",
"CI", "Yamoussoukro", "322460", "16393221",
"CL", "Santiago", "756950", "15328467",
"CM", "Yaound", "475440", "15803220",
"CN", "Beijing", "9596960", "1273111290",
"CO", "Bogot", "1138910", "40349388",
"CR", "San Jos", "51100", "3773057",
"CU", "Havana", "110860", "11184023",
"CV", "Praia", "4033", "405163",
"CY", "Nicosia", "9250", "762887",
"CZ", "Prague", "78866", "10264212",
"DE", "Berlin", "357021", "83029536",
"DJ", "Djibouti", "22000", "460700",
"DK", "Copenhagen", "43094", "5352815",
"DM", "Roseau", "754", "70786",
"DO", "Santo Domingo", "48730", "8581477",
"DZ", "Algiers", "2381740", "31736053",
"EC", "Quito", "283560", "13183978",
"EE", "Tallinn", "45226", "1423316",
"EG", "Cairo", "1001450", "69536644",
"EH", "!", "266000", "250559",
"ER", "Asmara", "121320", "4298269",
"ES", "Madrid", "504782", "40037995",
"ET", "Addis Ababa", "1127127", "65891874",
"FI", "Helsinki", "337030", "5175783",
"FJ", "Suva", "18270", "844330",
"FM", "Palikir", "702", "134597",
"FR", "Paris", "547030", "59551227",
"GA", "Libreville", "267667", "1221175",
"GB", "London", "244820", "59647790",
"GD", "Saint George's", "340", "89227",
"GE", "Tbilisi", "69700", "4989285",
"GF", "Georgetown", "214970", "697181",
"GH", "Accra", "238540", "19894014",
"GM", "Banjul", "11300", "1411205",
"GN", "Conakry", "245857", "7613870",
"GQ", "Malabo", "28051", "486060",
"GR", "Athens", "131940", "10623835",
"GT", "Guatemala City", "108890", "12974361",
"GW", "Bissau", "36120", "1315822",
"HN", "Tegucigalpa", "112090", "6406052",
"HR", "Zagreb", "56538", "4334142",
"HT", "Port-au-Prince", "27750", "6964549",
"HU", "Budapest", "93030", "10106017",
"ID", "Jakarta", "1919440", "228437870",
"IE", "Dublin", "70280", "3840838",
"IL", "Jerusalem", "20770", "5938093",
"IN", "New Delhi", "3287590", "1029991145",
"IQ", "Baghdad", "437072", "23331985",
"IR", "Tehran", "1648000", "66128965",
"IS", "Reykjavik", "103000", "277906",
"IT", "Rome", "301230", "57679825",
"JM", "Kingston", "10990", "2665636",
"JO", "Amman", "89213", "5153378",
"JP", "Tokyo", "377835", "126771662",
"KE", "Nairobi", "582650", "30765916",
"KG", "Bishkek", "198500", "4753003",
"KH", "Phnom Penh", "181040", "12491501",
"KI", "Tarawa", "717", "94149",
"KM", "Moroni", "2170", "596202",
"KN", "Basseterre", "261", "38756",
"KP", "Pyongyang", "120540", "21968228",
"KR", "Seoul", "98480", "47904370",
"KW", "Kuwait City", "17820", "2041961",
"KZ", "Almaty", "2717300", "16731303",
"LA", "Vientiane", "236800", "5635967",
"LB", "Beirut", "10400", "3627774",
"LC", "Castries", "620", "158178",
"LI", "Vaduz", "160", "32528",
"LK", "Colombo", "65610", "19408635",
"LR", "Monrovia", "111370", "3225837",
"LS", "Maseru", "30355", "2177062",
"LT", "Vilnius", "65200", "3610535",
"LU", "Luxembourg", "2586", "442972",
"LV", "Riga", "64589", "2385231",
"LY", "Tripoli", "1759540", "5240599",
"MA", "Rabat", "446550", "30645305",
"MC", "Monaco", "1.95", "31842",
"MD", "Chisinau", "33843", "4431570",
"MG", "Antananarivo", "587040", "15982563",
"MH", "Majuro", "181", "70822",
"MK", "Skopje", "25333", "2046209",
"ML", "Bamako", "1240000", "11008518",
"MM", "Rangoon", "678500", "41994678",
"MN", "Ulan Bator", "1565000", "2654999",
"MR", "Nouakchott", "1030700", "2747312",
"MT", "Valletta", "316", "394583",
"MU", "Port Louis", "1860", "1189825",
"MV", "Mal", "300", "310764",
"MW", "Lilongwe", "118480", "10548250",
"MX", "Mexico City", "1972550", "101879171",
"MY", "Kuala Lumpur", "329750", "22229040",
"MZ", "Maputo", "801590", "19371057",
"NA", "Windhoek", "825418", "1797677",
"NE", "Niamey", "1267000", "10355156",
"NG", "Abuja", "923768", "126635626",
"NI", "Managua", "129494", "4918393",
"NL", "Amsterdam", "41532", "15981472",
"NO", "Oslo", "324220", "4503440",
"NP", "Kathmandu", "140800", "25284463",
"NR", "Yaren", "21", "12088",
"NZ", "Wellington", "268680", "3864129",
"OM", "Muscat", "212460", "2622198",
"PA", "Panama City", "78200", "2845647",
"PE", "Lima", "1285220", "27483864",
"PG", "Port Moresby", "462840", "5049055",
"PH", "Manila", "300000", "82841518",
"PK", "Islamabad", "803940", "144616639",
"PL", "Warsaw", "312685", "38633912",
"PT", "Lisbon", "92391", "10066253",
"PW", "Koror", "458", "19092",
"PY", "Asuncin", "406750", "5734139",
"QA", "Doha", "11437", "769152",
"RO", "Bucharest", "237500", "22364022",
"RU", "Moscow", "17075200", "145470197",
"RW", "Kigali", "26338", "7312756",
"SA", "Riyadh", "1960582", "22757092",
"SB", "Honiara", "28450", "480442",
"SC", "Victoria", "455", "79715",
"SD", "Khartoum", "2505810", "36080373",
"SE", "Stockholm", "449964", "8875053",
"SG", "Singapore", "648", "4300419",
"SI", "Ljubljana", "20253", "1930132",
"SK", "Bratislava", "48845", "5414937",
"SL", "Freetown", "71740", "5426618",
"SM", "San Marino", "61", "27336",
"SN", "Dakar", "196190", "10284929",
"SO", "Mogadishu", "637657", "7488773",
"SR", "Paramaribo", "163270", "433998",
"ST", "So Tom", "1001", "165034",
"SV", "San Salvador", "21040", "6237662",
"SY", "Damascus", "185180", "16728808",
"SZ", "Mbabane", "17363", "1104343",
"TD", "N'Djamena", "1284000", "8707078",
"TG", "Lom", "56785", "5153088",
"TH", "Bangkok", "514000", "61797751",
"TJ", "Dushanbe", "143100", "6578681",
"TM", "Ashgabat", "488100", "4603244",
"TN", "Tunis", "163610", "9705102",
"TO", "Nuku'alofa", "748", "104227",
"TR", "Ankara", "780580", "66493970",
"TT", "Port-of-Spain", "5128", "1169682",
"TV", "Funafuti", "26", "10991",
"TW", "Taipei", "35980", "22370461",
"TZ", "Dar es Salaam", "945087", "36232074",
"UA", "Kyiv (Kiev)", "603700", "48760474",
"UG", "Kampala", "236040", "23985712",
"US", "Washington D.C.", "9629091", "278058881",
"UY", "Montevideo", "176220", "3360105",
"UZ", "Tashkent", "447400", "25155064",
"VA", "Vatican City", "0.44", "880",
"VC", "Kingstown", "389", "115942",
"VE", "Caracas", "912050", "23916810",
"VN", "Hanoi", "329560", "79939014",
"VU", "Vila", "14760", "192910",
"WS", "Apia", "2860", "179058",
"YE", "Sana", "527970", "18078035",
"YU", "Belgrade", "102350", "10677290",
"ZA", "Pretoria", "1219912", "43586097",
"ZM", "Lusaka", "752614", "9770199",
"ZW", "Harare", "390580", "11365366"
};

void usage()
{
    fprintf(stderr, 
       "Usage: loc_extract [-file name] [-format spec] [-separator string]\n");
    exit(0);
}

int main(int argc, char **argv)
{
    FILE *fd, *fdp;
    char buf[1024];
    char *filename=NULL, *format=NULL;
    char *str, *ptr, *ptrp;
    char field[20][120];
    char *separator = "|";
    int i, j, k, l, min, max, bool, num;
    int numcountries, numcurr, numextra;

    numcountries = sizeof(countries)/(2*sizeof(char *));
    numcurr = sizeof(currencies)/(2*sizeof(char *));
    numextra = sizeof(extradata)/(4*sizeof(char *));

    fprintf(stderr, "Number of countries/currencies %d %d\n", 
                    numcountries, numcurr);

    for (i=1; i<argc; i++) {
       if (!strncmp(argv[i], "-h", 2)) usage();
       else
       if (i<argc-1 && !strncmp(argv[i], "-file",4))
	  filename = strdup(argv[++i]);
       else
       if (i<argc-1 && !strncmp(argv[i], "-format",4))
	  format = strdup(argv[++i]);
       else
       if (i<argc-1 && !strncmp(argv[i], "-separator",4))
	  separator = strdup(argv[++i]);
    }

    if (!filename) {
       fprintf(stderr, "No file name specified !!\n");
       exit(-1);
    }
    if (!format) {
       fprintf(stderr, "No format specified !!\n");
       exit(-1);
    }
    fd =  fopen(filename, "r");
    if (!fd) {
       fprintf(stderr, "Can't open %s !!\n", filename);
       exit(-1);
    }
    min = 100;
    max = 0;
    l = strlen(format);
    while((str=fgets(buf, 1000, fd))) {
       if (*str=='%' || *str=='>') continue;
       i = 0;
       bool = 0;
       while (1) {
          while (str && *str && isspace(*str)) ++str;
	  ptr = str;
          while (*ptr && *ptr!='|') ++ptr;
	  if (!*ptr) bool=1;
          *ptr = '\0';
          ptrp = ptr+1;
	  --ptr;
          while(isspace(*ptr)) { *ptr = '\0'; --ptr; }
          strcpy(field[i], str);
	  ++i;
	  str = ptrp;
	  if (bool) break;
       }
       if (i>max) max = i;
       if (i<min) min = i;
       for (k=0; k<l; k++) {
	  j = format[k];
	  if (j>='0' && j<='9')
	     j = format[k] - '0';
	  else
	  if (j>='A' && j<='Z')
	     j = 10+format[k] - 'A';
	  else
	  if (j>='a' && j<='z')
	     j = 10+format[k] - 'a';
	  if (j==0) {
	     int p;
	     for (p=9; p<=12; p++)
	        field[p][0] = '\0';
	     for (p=0; p<numcountries; p++) {
	       if (!strcmp(field[j], countries[2*p])) {
		  strcpy(field[8], countries[2*p+1]);
		  break;
	       }
	     }
	     for (p=0; p<numcurr; p++) {
	       if (!strcmp(field[j], currencies[2*p])) {
		  strcpy(field[9], currencies[2*p+1]);
		  break;
	       }
	     }
	     for (p=0; p<numextra; p++) {
	       if (!strcmp(field[j], extradata[4*p])) {
		  strcpy(field[10], extradata[4*p+1]);
		  strcpy(field[11], extradata[4*p+2]);
		  strcpy(field[12], extradata[4*p+3]);
		  break;
	       }
	     }
	  }
	  if (j<i || j>=8)
	     printf("%s", field[j]);
	  else
             printf("(none)");
          if (k==l-1)
             printf("\n");
	  else
             printf("%s", separator);
       }
    }

    fprintf(stderr, "Number of fields: minimum %d, maximum %d\n", min, max);
    fclose(fd);
}






