#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <zlib.h>
#include <sys/stat.h>

char * var_codes[1464] = {
"AD", "AND", "ad", "020", "EUR (ADP) (FRF)", "+376",
"AE", "ARE", "ae", "784", "AED", "+971",
"AF", "AFG", "af", "004", "AFA", "+93",
"AG", "ATG", "us,ag", "028", "XCD", "+1[268]",
"AI", "AIA", "gb,ai", "660", "XCD", "+1[264]",
"AL", "ALB", "al", "008", "ALL", "+355",
"AM", "ARM", "am", "051", "AMD", "+374",
"AN", "ANT", "nl,an", "530", "ANG", "+599",
"AO", "AGO", "ao", "024", "(AON) AOR", "+244",
"AQ", "ATA", "aq", "010", "(USD) (AUD)", "+672[(1)]",
"AR", "ARG", "ar", "032", "ARS", "+54",
"AS", "ASM", "us,as", "016", "USD", "+684",
"AT", "AUT", "at", "040", "EUR (ATS)", "+43",
"AU", "AUS", "au", "036", "AUD", "+61",
"AW", "ABW", "nl,aw", "533", "AWG", "+297",
"AZ", "AZE", "az", "031", "AZM", "+994",
"BA", "BIH", "ba", "070", "EUR (DEM)", "+387",
"BB", "BRB", "bb", "052", "BBD", "+1[246]",
"BD", "BGD", "bd", "050", "BDT", "+880",
"BE", "BEL", "be", "056", "EUR (BEF)", "+32",
"BF", "BFA", "bf", "854", "XOF", "+226",
"BG", "BGR", "bg", "100", "BGL", "+359",
"BH", "BHR", "bh", "048", "BHD", "+973",
"BI", "BDI", "bi", "108", "BIF", "+257",
"BJ", "BEN", "bj", "204", "XOF", "+229",
"BM", "BMU", "gb", "060", "BMD", "+1[441]",
"BN", "BRN", "bn", "096", "BND", "+673",
"BO", "BOL", "bo", "068", "BOB (BOV)", "+591",
"BR", "BRA", "br", "076", "BRL", "+55",
"BS", "BHS", "bs", "044", "BSD", "+1[242]",
"BT", "BTN", "bt", "064", "BTN (INR)", "+975",
"BV", "BVT", "no", "074", "NOK", "+47[(01)]",
"BW", "BWA", "bw", "072", "BWP", "+267",
"BY", "BLR", "by", "112", "BYB", "+375",
"BZ", "BLZ", "bz", "084", "BZD", "+501",
"CA", "CAN", "ca", "124", "CAD", "+1[(1)]",
"CC", "CCK", "au", "166", "AUD", "+61[(01)]",
"CD", "COD", "cd", "180", "ZRN", "+243",
"CF", "CAF", "cf", "140", "XAF", "+236",
"CG", "COG", "cg", "178", "XAF", "+242",
"CH", "CHE", "ch", "756", "CHF", "+41",
"CI", "CIV", "ci", "384", "XOF", "+225",
"CK", "COK", "nz", "184", "NZD", "+682",
"CL", "CHL", "cl", "152", "(CLF) CLP", "+56",
"CM", "CMR", "cm", "120", "XAF", "+237",
"CN", "CHN", "cn", "156", "CNY", "+86[(-)]",
"CO", "COL", "co", "170", "COP", "+57",
"CR", "CRI", "cr", "188", "CRC", "+506",
"CU", "CUB", "cu", "192", "CUP", "+53",
"CV", "CPV", "cv", "132", "CVE", "+238",
"CX", "CXR", "au,cx", "162", "AUD", "+672[(01)]",
"CY", "CYP", "cy", "196", "CYP", "+357",
"CZ", "CZE", "cz", "203", "CZK", "+420",
"DE", "DEU", "de", "276", "EUR (DEM)", "+49",
"DJ", "DJI", "dj", "262", "DJF", "+253",
"DK", "DNK", "dk", "208", "EUR (DKK)", "+45",
"DM", "DMA", "dm", "212", "XCD", "+1[767]",
"DO", "DOM", "do", "214", "DOP", "+1[809]",
"DZ", "DZA", "dz", "012", "DZD", "+213",
"EC", "ECU", "ec", "218", "ECS (ECV)", "+593",
"EE", "EST", "ee", "233", "EEK", "+372",
"EG", "EGY", "eg", "818", "EGP", "+20",
"EH", "ESH", "eh", "732", "MAD", "+212[(1)]",
"ER", "ERI", "er", "232", "", "+291",
"ES", "ESP", "es", "724", "EUR (ESP)", "+34",
"ET", "ETH", "et", "231", "ETB", "+251",
"FI", "FIN", "fi", "246", "EUR (FIM)", "+358",
"FJ", "FJI", "us,fj", "242", "FJD", "+679",
"FK", "FLK", "gb,fk", "238", "FKP (GBP) (XEU)", "+500",
"FM", "FSM", "fm", "583", "USD", "+691",
"FO", "FRO", "dk,fo", "234", "DKK (XEU)", "+298",
"FR", "FRA", "fr", "250", "EUR (FRF)", "+33[(-)]",
"FX", "FXX", "fr", "249", "EUR (FRF)", "+33[(00)]",
"GA", "GAB", "ga", "266", "XAF", "+241",
"GB", "GBR", "gb", "826", "GBP (XEU)", "+44[(00)]",
"GD", "GRD", "gd", "308", "XCD", "+1[473]",
"GE", "GEO", "ge", "268", "GEL", "+995",
"GF", "GUF", "fr", "254", "EUR (FRF)", "+594",
"GG", "GUE", "gb,gg", "-", "GGP GBP (XEU)", "+44[(02)]",
"GH", "GHA", "gh", "288", "GHC", "+233",
"GI", "GIB", "gb,gi", "292", "GIP (GBP) (XEU)", "+350",
"GL", "GRL", "dk,gl", "304", "DKK (XEU)", "+299",
"GM", "GMB", "gm", "270", "GMD", "+220",
"GN", "GIN", "gn", "324", "GNF", "+224",
"GP", "GLP", "fr,gp", "312", "EUR (FRF)", "+590",
"GQ", "GNQ", "gq", "226", "XAF", "+240",
"GR", "GRC", "gr", "300", "EUR (GRD)", "+30",
"GS", "SGS", "gb", "239", "FKP (GBP) (XEU)", "+500[(01)]",
"GT", "GTM", "gt", "320", "GTQ", "+502",
"GU", "GUM", "us,gu", "316", "USD", "+1[671]",
"GW", "GNB", "gw", "624", "GWP", "+245",
"GY", "GUY", "gy", "328", "GYD", "+592",
"HK", "HKG", "cn", "344", "HKD (CNY)", "+852",
"HM", "HMD", "au", "334", "AUD", "+61[(02)]",
"HN", "HND", "hn", "340", "HNL", "+504",
"HR", "HRV", "hr", "191", "HRK", "+385",
"HT", "HTI", "ht", "332", "HTG (USD)", "+509",
"HU", "HUN", "hu", "348", "HUF", "+36",
"ID", "IDN", "id", "360", "IDR", "+62",
"IE", "IRL", "ie", "372", "EUR (IEP)", "+353",
"IL", "ISR", "il", "376", "ILS", "+972",
"IM", "IMA", "gb,im", "", "GBP (XEU)", "+44[(01)]",
"IN", "IND", "in", "356", "INR", "+91",
"IO", "IOT", "gb", "086", "GBP", "+873[(01)] [(INMAR SAT)]",
"IQ", "IRQ", "iq", "368", "IQD", "+964",
"IR", "IRN", "ir", "364", "IRR", "+98",
"IS", "ISL", "is", "352", "ISK", "+354",
"IT", "ITA", "it", "380", "EUR (ITL)", "+39",
"JE", "JER", "gb,je", "-", "JEP GBP (XEU)", "+44[(03)]",
"JM", "JAM", "jm", "388", "JMD", "+1[876]",
"JO", "JOR", "jo", "400", "JOD", "+962",
"JP", "JPN", "jp", "392", "JPY", "+81",
"KE", "KEN", "ke", "404", "KES", "+254",
"KG", "KGZ", "kg", "417", "KGS", "+996",
"KH", "KHM", "kh", "116", "KHR", "+855",
"KI", "KIR", "ki", "296", "AUD", "+686",
"KM", "COM", "km", "174", "KMF", "+269[7]",
"KN", "KNA", "kn", "659", "XCD", "+1[869]",
"KP", "PRK", "kp", "408", "KPW", "+850",
"KR", "KOR", "kr", "410", "KRP", "+82",
"KW", "KWT", "kw", "414", "KWD", "+965",
"KY", "CYM", "gb,ky", "136", "KYD", "+1[345]",
"KZ", "KAZ", "kz", "398", "KZT", "+7[(05)] +997*",
"LA", "LAO", "la", "418", "LAK", "+856",
"LB", "LBN", "lb", "422", "LBP", "+961",
"LC", "LCA", "lc", "662", "XCD", "+1[758]",
"LI", "LIE", "li", "438", "CHF", "+423",
"LK", "LKA", "lk", "144", "LKR", "+94",
"LR", "LBR", "lr", "430", "LRD", "+231",
"LS", "LSO", "ls", "426", "LSL (SAR)", "+266",
"LT", "LTU", "lt", "440", "LTL", "+370",
"LU", "LUX", "lu", "442", "EUR (LUF) (BEF)", "+352",
"LV", "LVA", "lv", "428", "LVL", "+371",
"LY", "LBY", "ly", "434", "LYD", "+218",
"MA", "MAR", "ma", "504", "MAD", "+212",
"MC", "MCO", "mc", "492", "EUR (FRF)", "+377",
"MD", "MDA", "md", "498", "MDL", "+373",
"MG", "MDG", "mg", "450", "MGF", "+261",
"MH", "MHL", "us,mh", "584", "USD", "+692",
"MK", "MKD", "mk", "807", "MKD", "+389",
"ML", "MLI", "ml", "466", "XOF", "+223",
"MM", "MMR", "mm", "104", "MMK", "+95",
"MN", "MNG", "mn", "496", "MNT", "+976",
"MO", "MAC", "cn,mo", "446", "MOP (CNY)", "+853",
"MP", "MNP", "us", "580", "USD", "+1[670]",
"MQ", "MTQ", "fr", "474", "EUR (FRF)", "+596",
"MR", "MRT", "mr", "478", "MRO", "+222",
"MS", "MSR", "gb", "500", "GBP", "+1[664]",
"MT", "MLT", "mt", "470", "MTL", "+356",
"MU", "MUS", "mu", "480", "MUR", "+230",
"MV", "MDV", "mv", "462", "MVR", "+960",
"MW", "MWI", "mw", "454", "MWK", "+265",
"MX", "MEX", "mx", "484", "MXN (MXP*)", "+52",
"MY", "MYS", "my", "458", "MYR", "+60",
"MZ", "MOZ", "mz", "508", "MZM", "+258",
"NA", "NAM", "na", "516", "NAD (ZAR)", "+264",
"NC", "NCL", "fr,nc", "540", "XPF", "+687",
"NE", "NER", "ne", "562", "XOF", "+227",
"NF", "NFK", "au,nf", "574", "AUD", "+672[(02)]",
"NG", "NGA", "ng", "566", "NGN", "+234",
"NI", "NIC", "ni", "558", "NIO", "+505",
"NL", "NLD", "nl", "528", "EUR (NLG)", "+31",
"NO", "NOR", "no", "578", "NOK", "+47[(-)]",
"NP", "NPL", "np", "524", "NPR", "+977",
"NR", "NRU", "nr", "520", "AUD", "+674",
"NU", "NIU", "nu", "570", "NZD", "+683",
"NZ", "NZL", "nz", "554", "NZD", "+64",
"OM", "OMN", "om", "512", "OMR", "+968",
"PA", "PAN", "pa", "591", "PAB (USD)", "+507",
"PC", "PAR", "cn", "", "CNY", "+86[(01)]",
"PE", "PER", "pe", "604", "PEN (PES)", "+51",
"PF", "PYF", "fr,pf", "258", "XPF (FRF) (XEU)", "+689",
"PG", "PNG", "pg", "598", "PGK", "+675",
"PH", "PHL", "ph", "608", "PHP", "+63",
"PK", "PAK", "pk", "586", "PKR", "+92",
"PL", "POL", "pl", "616", "PLN (PLZ)", "+48",
"PM", "SPM", "fr", "666", "EUR FRF", "+508",
"PN", "PCN", "nz,pn", "612", "NZD", "+64[(1)]",
"PR", "PRI", "us", "630", "USD", "+1[787] +1[939]*",
"PS", "PSE", "ps", "275", "ILS (JOD)", "+970",
"PT", "PRT", "pt", "620", "EUR (PTE)", "+351",
"PW", "PLW", "pw", "585", "USD", "+680",
"PY", "PRY", "py", "600", "PYG", "+595",
"QA", "QAT", "qa", "634", "QAR", "+974",
"RE", "REU", "fr,re", "638", "EUR (FRF)", "+33[262]* +262",
"RO", "ROM", "ro", "642", "ROL", "+40",
"RU", "RUS", "ru", "643", "RUR", "+7[(-)]",
"RW", "RWA", "rw", "646", "RWF", "+250",
"SA", "SAU", "sa", "682", "SAR", "+966",
"SB", "SLB", "sb", "090", "SBD", "+677",
"SC", "SYC", "sc", "690", "SCR", "+248",
"SD", "SDN", "sd", "736", "SDD", "+249",
"SE", "SWE", "se", "752", "EUR (SEK)", "+46",
"SG", "SGP", "sg", "702", "SGD", "+65",
"SH", "SHN", "gb,sh", "654", "SHP", "+290",
"SI", "SVN", "si", "705", "SIT", "+386",
"SJ", "SJM", "no", "744", "NOK", "+47[(1)]",
"SK", "SVK", "sk", "703", "SKK", "+421",
"SL", "SLE", "sl", "694", "SLL", "+232",
"SM", "SMR", "sm", "674", "EUR (ITL)", "+378",
"SN", "SEN", "sn", "686", "XOF", "+221",
"SO", "SOM", "so", "706", "SOS", "+252",
"SR", "SUR", "sr", "740", "SRG", "+597",
"ST", "STP", "st", "678", "STD", "+239",
"SV", "SLV", "sv", "222", "SVC", "+503",
"SY", "SYR", "sy", "760", "SYP", "+963",
"SZ", "SWZ", "sz", "748", "SZL", "+268",
"TC", "TCA", "gb,tc", "796", "USD", "+1[649]",
"TD", "TCD", "td", "148", "XAF", "+235",
"TF", "ATF", "fr,aq", "260", "EUR (FRF)", "+61[(2)]",
"TG", "TGO", "tg", "768", "XOF", "+228",
"TH", "THA", "th", "764", "THB", "+66",
"TJ", "TJK", "tj", "762", "TJR", "+992",
"TK", "TKL", "nz,tk", "772", "NZD", "+690",
"TM", "TKM", "tm", "795", "TMM", "+993",
"TN", "TUN", "tn", "788", "TND", "+21[6]",
"TO", "TON", "to", "776", "TOP", "+676",
"TP", "TMP", "tp", "626", "IDR (TPE)", "+670",
"TR", "TUR", "tr", "792", "TRL", "+90",
"TT", "TTO", "tt", "780", "TTD", "+1[868]",
"TV", "TUV", "tv", "798", "AUD", "+688",
"TW", "TWN", "tw", "158", "TWD", "+886 +86[6]*",
"TZ", "TZA", "tz", "834", "TZS", "+255 +259*",
"UA", "UKR", "ua", "804", "UAH UAK", "+380",
"UG", "UGA", "ug", "800", "UGX", "+256",
"UM", "UMI", "us", "581", "USD", "+1[(19)]",
"US", "USA", "us", "840", "USD", "+1[(-)]",
"UY", "URY", "uy", "858", "UYU", "+598",
"UZ", "UZB", "uz", "860", "UZS", "+998",
"VA", "VAT", "it,va", "336", "EUR (ITL)", "+379",
"VC", "VCT", "vc", "670", "XCD", "+1[784]",
"VE", "VEN", "ve", "862", "VEB", "+58",
"VG", "VGB", "gb,vg", "092", "USD", "+1[284]",
"VI", "VIR", "us,vi", "850", "USD", "+1[340]",
"VN", "VNM", "vn", "704", "VND", "+84",
"VU", "VUT", "vu", "548", "VUV", "+678",
"WF", "WLF", "fr,wf", "876", "XPF", "+681",
"WS", "WSM", "ws", "882", "WST", "+685",
"YE", "YEM", "ye", "887", "YER", "+967",
"YT", "MYT", "fr", "175", "EUR (FRF)", "+269[(-)]",
"YU", "YUG", "yu", "891", "YUM", "+381",
"ZA", "ZAF", "za", "710", "ZAR (ZAL)", "+27",
"ZM", "ZMB", "zm", "894", "ZMK", "+260",
"ZW", "ZWE", "zw", "716", "ZWD", "+263"
};

void usage()
{
    fprintf(stderr, 
       "Usage: loc_extract [-file name] [-format spec] [-separator string]\n");
    exit(0);
}

int main(int argc, char **argv)
{
    FILE *fd, *fdp;
    char buf[1024];
    char *filename=NULL, *format=NULL;
    char *str, *ptr, *ptrp;
    char field[20][120];
    char *separator = "|";
    int i, j, k, l, min, max, bool, num;

    for (i=1; i<argc; i++) {
       if (!strncmp(argv[i], "-h", 2)) usage();
       else
       if (i<argc-1 && !strncmp(argv[i], "-file",4))
	  filename = strdup(argv[++i]);
       else
       if (i<argc-1 && !strncmp(argv[i], "-format",4))
	  format = strdup(argv[++i]);
       else
       if (i<argc-1 && !strncmp(argv[i], "-separator",4))
	  separator = strdup(argv[++i]);
    }

    if (!filename) {
       fprintf(stderr, "No file name specified !!\n");
       exit(-1);
    }
    if (!format) {
       fprintf(stderr, "No format specified !!\n");
       exit(-1);
    }
    fd =  fopen(filename, "r");
    if (!fd) {
       fprintf(stderr, "Can't open %s !!\n", filename);
       exit(-1);
    }
    min = 100;
    max = 0;
    l = strlen(format);
    while((str=fgets(buf, 1000, fd))) {
       if (*str=='%' || *str=='>') continue;
       i = 0;
       bool = 0;
       while (1) {
          while (str && *str && isspace(*str)) ++str;
	  ptr = str;
          while (*ptr && *ptr!='|') ++ptr;
	  if (!*ptr) bool=1;
          *ptr = '\0';
          ptrp = ptr+1;
	  --ptr;
          while(isspace(*ptr)) { *ptr = '\0'; --ptr; }
          if (i==0) {
	     for (k=0; k<244; k++) if (!strcmp(str,var_codes[6*k])) {
	        strcpy(field[i], var_codes[6*k+1]);
		break;
	     }
	  } else
            strcpy(field[i], str);
	  ++i;
	  str = ptrp;
	  if (bool) break;
       }
       if (i>max) max = i;
       if (i<min) min = i;
       for (k=0; k<l; k++) {
	  j = format[k];
	  if (j>='0' && j<='9')
	     j = format[k] - '0';
	  else
	  if (j>='A' && j<='Z')
	     j = 10+format[k] - 'A';
	  else
	  if (j>='a' && j<='z')
	     j = 10+format[k] - 'a';
	  if (j<i)
	     printf("%s", field[j]);
	  else
             printf("(none)");
          if (k==l-1)
             printf("\n");
	  else
             printf("%s", separator);
       }
    }

    fprintf(stderr, "Number of fields: minimum %d, maximum %d\n", min, max);
    fclose(fd);
}






